{
  "type": "minecraft:tree",
  "config": {
    "dirt_provider": {
      "type": "minecraft:simple_state_provider",
      "state": {
        "Name": "minecraft:air"
      }
    },
    "foliage_provider": {
      "type": "minecraft:simple_state_provider",
      "state": {
        "Name": "minecraft:air"
      }
    },
    "trunk_provider": {
      "type": "minecraft:simple_state_provider",
      "state": {
        "Name": "minecraft:air"
      }
    },
    "root_placer": {
      "type": "minecraft:mangrove_root_placer",
      "root_provider": {
        "type": "minecraft:simple_state_provider",
        "state": {
          "Name": "minecraft:bone_block"
        }
      },
      "trunk_offset_y": {
        "type": "uniform",
        "min_inclusive": 1,
        "max_inclusive": 3
      },
      "above_root_placement": {
        "above_root_placement_chance": 0.5,
        "above_root_provider": {
          "type": "minecraft:simple_state_provider",
          "state": {
            "Name": "minecraft:air"
          }
        }
      },
      "mangrove_root_placement": {
        "can_grow_through": "#mangrove_roots_can_grow_through",
        "muddy_roots_in": "#dirt",
        "muddy_roots_provider": {
          "type": "minecraft:simple_state_provider",
          "state": {
            "Name": "minecraft:air"
          }
        },
        "max_root_length": 15,
        "max_root_width": 8,
        "random_skew_chance": 0.2
      }
    },
    "force_dirt": false,
    "ignore_vines": true,
    "foliage_placer": {
      "type": "minecraft:random_spread_foliage_placer",
      "radius": 3,
      "offset": 0,
      "foliage_height": 2,
      "leaf_placement_attempts": 1
    },
    "trunk_placer": {
      "type": "minecraft:upwards_branching_trunk_placer",
      "base_height": 1,
      "height_rand_a": 1,
      "height_rand_b": 1,
      "can_grow_through": "#minecraft:replaceable_by_trees",
      "place_branch_per_log_probability": 1,
      "extra_branch_length": {
        "type": "minecraft:uniform",
        "min_inclusive": 0,
        "max_inclusive": 1
      },
      "extra_branch_steps": {
        "type": "minecraft:uniform",
        "min_inclusive": 1,
        "max_inclusive": 6
      }
    },
    "minimum_size": {
      "type": "minecraft:two_layers_feature_size",
      "limit": 3,
      "lower_size": 0,
      "upper_size": 2
    },
    "decorators": []
  }
}